package map;

public class ArrayedMap {
	private final int MAX_CAPCAITY = 100;
	private Entry[] entries;
	/*
	 * This attribute denotes:
	 * 1. Number of entries in the map
	 * 2. Index for storing the next entry 
	 */
	private int noe; 
	
	/*
	 * Initialize an empty map (i.e., noe is zero).
	 */
	public ArrayedMap() {
		entries = new Entry[MAX_CAPCAITY];
		noe = 0;
	}
	
	public int size() {
		return noe;
	}
	
	/*
	 * Add a new entry to the map.
	 * For simplicity, we assume that the new entry does 
	 * not exist in the current map.
	 * EXERCISE: Add a precondition check, so that
	 * adding a new entry with its key already existing will
	 * trigger an exception. 
	 */
	public void put(int key, String value) {
		Entry e = new Entry(key, value);
		entries[noe] = e;
		noe ++;
	}
	
	/*
	 * Currently for simplicity, it is assume that an 
	 * existing key is given to find its associated value.
	 * EXERCISE: Add a precondition check, so that
	 * passing a non-existing key will trigger an exception.
	 */
	public String getValue(int key) { 
		/* 
		 * Writing "i < entries.length" as the stay condition is wrong! 
		 */
		for(int i = 0; i < noe; i ++) {
			Entry e = entries[i];
			int k = e.getKey(); 
			if(k == key) {
				return e.getValue();
			}
		} 
		return null;
	}
}
